<template>
        <row class="app-layoutpanel " style="width:100%;height:100%;">
        <i-col v-show="detailsModel.container1.visible"  :md="{ span: 24, offset: 0 }" :lg="{ span: 24, offset: 0 }"  class="app-layoutpanel-container" style="width:;height:100%;">
            <row style="height:100%;">
                      
                <i-col v-show="detailsModel.author.visible"  :md="{ span: 24, offset: 0 }" style="" class="app-layoutpanel-field">
                    <div class="item-field">
                    <app-panel-field
                      name='author'
                      labelPos='LEFT'
                      caption="作者"
                      :isEmptyCaption="false"
                      :error='detailsModel.author.error'
                      :data='data'
                      :value='data.author'
                      :itemRules="rules.author">
                    
                <app-span :value="data.author" name="author" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""> </app-span> 
                
                    </app-panel-field>
                </div>
                
                
                </i-col>
                      
                <i-col v-show="detailsModel.press.visible"  :md="{ span: 24, offset: 0 }" style="" class="app-layoutpanel-field">
                    <div class="item-field">
                    <app-panel-field
                      name='press'
                      labelPos='LEFT'
                      caption="出版社"
                      :isEmptyCaption="false"
                      :error='detailsModel.press.error'
                      :data='data'
                      :value='data.press'
                      :itemRules="rules.press">
                    
                <app-span :value="data.press" name="press" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""> </app-span> 
                
                    </app-panel-field>
                </div>
                
                
                </i-col>
                      
                <i-col v-show="detailsModel.bookname.visible"  :md="{ span: 24, offset: 0 }" style="" class="app-layoutpanel-field">
                    <div class="item-field">
                    <app-panel-field
                      name='bookname'
                      labelPos='LEFT'
                      caption="图书名"
                      :isEmptyCaption="false"
                      :error='detailsModel.bookname.error'
                      :data='data'
                      :value='data.bookname'
                      :itemRules="rules.bookname">
                    
                <app-span :value="data.bookname" name="bookname" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""> </app-span> 
                
                    </app-panel-field>
                </div>
                
                
                </i-col>
            </row>
        </i-col>
    </row>

</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZBOOKEntityService from '@/service/ibizbook/ibizbook-service';
import Usr4Service from './usr4-panel-service';
import IBIZBOOKUIService from '@/uiservice/ibizbook/ibizbook-ui-service';
import { PanelDetailModel,PanelRawitemModel,PanelTabPanelModel,PanelTabPageModel,PanelFieldModel,PanelContainerModel,PanelControlModel,PanelUserControlModel,PanelButtonModel } from '@/model/panel-detail';
import Usr4Model from './usr4-panel-model';
import CodeListService from "@/codelist/codelist-service";
import UIService from '@/uiservice/ui-service';


@Component({
    components: {
      
    }
})
export default class Usr4Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Usr4Base
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Usr4Base
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Usr4Base
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Usr4Base
     */
    @Prop() public viewparams!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Usr4Base
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Usr4Base
     */
    public getControlType(): string {
        return 'PANEL'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Usr4Base
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Usr4Service}
     * @memberof Usr4Base
     */
    public service: Usr4Service = new Usr4Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZBOOKService}
     * @memberof Usr4Base
     */
    public appEntityService: IBIZBOOKEntityService = new IBIZBOOKEntityService({ $store: this.$store });
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  Usr4Base
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Usr4Base
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Usr4Base
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 接口实现
     *
     * @returns {any[]}
     * @memberof Usr4Base
     */
    getDatas(): any[] {
        if (!this.panelData) {
            return [];
        }
        return [this.panelData];
    }

    /**
     * 接口实现
     *
     * @returns {*}
     * @memberof Usr4Base
     */
    getData() {
        return this.panelData;
    }

    /**
     * 父级部件引用
     *
     * @type {*}
     * @memberof Usr4Base
     */
    @Prop() public parentRef?: any;

    /**
     * 面板数据对象
     *
     * @type {*}
     * @memberof Usr4Base
     */
    @Prop() public inputData?: any;

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof Usr4Base
     */
    @Prop() public actionModel?: any;

    /**
     * UI数据对象
     *
     * @type {*}
     * @memberof Usr4Base
     */
    public data:any = {};

    /**
     * 面板数据对象
     *
     * @type {*}
     * @memberof Usr4Base
     */
    public panelData:any = null;

    /**
     * 数据模型对象
     *
     * @type {Usr4Model}
     * @memberof Usr4Base
     */
    public dataModel:Usr4Model = new Usr4Model();

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof Usr4Base
     */
    public codeListService:CodeListService = new CodeListService();

    /**
     * 界面UI服务对象
     *
     * @type {IBIZBOOKUIService}
     * @memberof Usr4Base
     */  
    public appUIService:IBIZBOOKUIService = new IBIZBOOKUIService();

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Usr4Base
     */
    public detailsModel: any = {
        author: new PanelFieldModel({ caption: '作者', itemType: 'FIELD',visible: true, disabled: false, name: 'author', panel: this })
,
        press: new PanelFieldModel({ caption: '出版社', itemType: 'FIELD',visible: true, disabled: false, name: 'press', panel: this })
,
        bookname: new PanelFieldModel({ caption: '图书名', itemType: 'FIELD',visible: true, disabled: false, name: 'bookname', panel: this })
,
        container1: new PanelContainerModel({ caption: '', itemType: 'CONTAINER',visible: true, disabled: false, name: 'container1', panel: this })
,
    };

    /**
     * 值规则对象
     *
     * @type {*}
     * @memberof Usr4Base
     */
    public rules:any={
        author:[
            { required: false, type: 'string', message: '作者 值不能为空'},
            { required: false, type: 'string', message: '作者 值不能为空'}
        ],
        press:[
            { required: false, type: 'string', message: '出版社 值不能为空'},
            { required: false, type: 'string', message: '出版社 值不能为空'}
        ],
        bookname:[
            { required: false, type: 'string', message: '图书名 值不能为空'},
            { required: false, type: 'string', message: '图书名 值不能为空'}
        ],
    };

    /**
     * 监听数据对象
     *
     * @memberof Usr4Base
     */
    @Watch('inputData',{immediate:true,deep: true})
    public onInputDataChange(newVal: any, oldVal: any){
        if(newVal){
            this.computedUIData(newVal);
            this.panelData = Util.deepCopy(newVal);
            this.computeButtonState(newVal);
            this.panelLogic({ name: '', newVal: null, oldVal: null });
            this.$forceUpdate();
        }
    }

    /**
     * 计算UI展示数据
     * 
     * @param codelistArray 代码表模型数组
     * @memberof Usr4Base
     */
    public computedUIData(newVal:any){
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            this.dataModel.getDataItems().forEach((item:any) =>{
                this.data[item.name] = newVal[item.prop];
            })
        }
    }

    /**
     * 计算面板按钮权限状态
     *
     * @param {*} [data] 传入数据
     * @memberof Usr4Base
     */
    public computeButtonState(data:any){
        // 若为项布局面板，存在parentRef
        if(this.parentRef){
            let targetData:any = this.parentRef.transformData(data);
            if(this.detailsModel && Object.keys(this.detailsModel).length >0){
                Object.keys(this.detailsModel).forEach((name:any) =>{
                    if(this.detailsModel[name] && this.detailsModel[name].uiaction && this.detailsModel[name].uiaction.dataaccaction && Object.is(this.detailsModel[name].itemType,"BUTTON")){
                        this.detailsModel[name].isPower = true;
                        let tempUIAction:any = JSON.parse(JSON.stringify(this.detailsModel[name].uiaction));
                        let result: any[] = ViewTool.calcActionItemAuthState(targetData,[tempUIAction],this.appUIService?this.appUIService:null);
                        this.detailsModel[name].visible = tempUIAction.visabled;
                        this.detailsModel[name].disabled = tempUIAction.disabled;
                        this.detailsModel[name].isPower = result[0] === 1 ? true : false;
                    }
                })
            }
        }
    }

    /**
     * 界面行为
     *
     * @param {*} row
     * @param {*} tag
     * @param {*} $event
     * @memberof Usr4Base
     */
    public uiAction(row: any, tag: any, $event: any) {
    }

    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof Usr4Base
     */
    public opendata(args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any){
        if (this.parentRef.opendata && this.parentRef.opendata instanceof Function) {
            this.parentRef.opendata(args,fullargs,params, $event, xData);
        }
    }

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof Usr4Base
     */
    public newdata(args: any[],fullargs?:any[], params?: any, $event?: any, xData?: any) {
        if (this.parentRef.newdata && this.parentRef.newdata instanceof Function) {
            this.parentRef.newdata(args,fullargs,params, $event, xData);
        }
    }
    
    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof Usr4Base
     */
    public async remove(datas: any[]): Promise<any> {
        if (this.parentRef.remove && this.parentRef.remove instanceof Function) {
            return this.parentRef.remove(datas);
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof Usr4Base
     */
    public refresh(args: any = {}) {
        if (this.parentRef.refresh && this.parentRef.refresh instanceof Function) {
            this.parentRef.refresh(args);
        }
    }

    /**
     * 设置变更面板编辑项的值
     *  
     * @param data 面板数据
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Usr4Base
     */
    public onPanelItemValueChange(data: any,$event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !data.hasOwnProperty($event.name)) {
            return;
        }
        data[$event.name] = $event.value;
        this.panelEditItemChange(data, $event.name, $event.value);
    }

    /**
     * 面板编辑项值变化后续操作
     *
     * @public
     * @param data 面板数据
     * @param property 编辑项名
     * @param value 编辑项值
     * @returns {void}
     * @memberof Usr4Base
     */
    public panelEditItemChange(data: any, property: string, value: any){
        // 面板数据变化事件
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            let modelitem =this.dataModel.getDataItems().find((item:any) =>{
                return item.name === property;
            }) 
            if(modelitem){
                this.$emit('panelDataChange',{[modelitem.prop]: value});
            }
        }

    }

    /**
     * 分页切换事件
     *
     * @memberof Usr4Base
     */
    public handleTabPanelClick(name:string,$event:any){
        this.detailsModel[name].clickPage($event.name);
    }

    /**
     * 面板逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Usr4Base
     */
    public panelLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                




    }

}
</script>

<style lang='less'>
@import './usr4-panel.less';
</style>

